package cn.muchinfo.rma.view.base.home.commodity

import android.view.View
import android.view.ViewGroup
import androidx.appcompat.app.AppCompatActivity
import androidx.viewpager.widget.PagerAdapter
import androidx.viewpager.widget.ViewPager
import cn.muchinfo.rma.R
import cn.muchinfo.rma.global.data.MiddleGoodsData
import cn.muchinfo.rma.global.data.WrStandardData
import cn.muchinfo.rma.lifecycle.bindOptional
import cn.muchinfo.rma.view.autoWidget.*
import com.blankj.utilcode.util.ConvertUtils
import com.qmuiteam.qmui.util.QMUIDisplayHelper
import com.qmuiteam.qmui.widget.tab.QMUITabIndicator
import com.qmuiteam.qmui.widget.tab.QMUITabSegment
import mtp.polymer.com.autowidget.adapter.BaseAdapter
import org.jetbrains.anko._FrameLayout
import org.jetbrains.anko.matchParent
import org.jetbrains.anko.support.v4.viewPager
import org.jetbrains.anko.verticalLayout
import org.jetbrains.anko.view


/**
 * 套保品种
 * @property activity AppCompatActivity
 * @property viewModel CommodityInformationViewModel
 * @property root _FrameLayout
 * @constructor
 */
class HedgeSpeciesUI(
    private val activity: AppCompatActivity,
    private val viewModel: CommodityInformationViewModel
) {

    lateinit var segment: QMUITabSegment
    var selectedTabIndex: Int = 0
    private lateinit var viewPager: ViewPager

    private val tabsArray: List<String> by lazy {
        arrayListOf(
            "正常", "停用"
        )
    }
    private val hedgeSpeciesNormalUI by lazy { HedgeSpeciesNormalUI(activity, viewModel) }
    val hedgeSpeciesStopUI by lazy { HedgeSpeciesStopUI(activity, viewModel) }

    private val pagerAdapter: PagerAdapter by lazy {
        object : PagerAdapter() {

            override fun getPageTitle(position: Int): CharSequence? = tabsArray[position]

            override fun instantiateItem(container: ViewGroup, position: Int): Any {
                when (position) {
                    0 -> {
                        return hedgeSpeciesNormalUI.root.apply {
                            container.addView(
                                this,
                                ViewGroup.LayoutParams(matchParent, matchParent)
                            )
                        }
                    }
                    1 -> {
                        return hedgeSpeciesStopUI.root.apply {
                            container.addView(
                                this,
                                ViewGroup.LayoutParams(matchParent, matchParent)
                            )
                        }
                    }
                    else -> return super.instantiateItem(container, position)
                }
            }

            override fun destroyItem(container: ViewGroup, position: Int, `object`: Any) {
                (`object` as? View)?.let { container.removeView(it) }
            }

            override fun isViewFromObject(view: View, `object`: Any): Boolean = view == `object`

            override fun getCount(): Int = tabsArray.size

        }
    }

    //每次重回页面刷新数据
    fun refrashData(){
        if (selectedTabIndex == 0){
            viewModel.queryMiddleGoodsList(status = "1")
        }else{
            viewModel.queryMiddleGoodsList(status = "0")
        }
    }

    val root = _FrameLayout(activity).apply {
        verticalLayout {
            tabSegment {
                segment = this
                background = resources.getDrawable(R.color.white)
                addOnTabSelectedListener(object :
                    QMUITabSegment.OnTabSelectedListener {
                    override fun onDoubleTap(index: Int) {}
                    override fun onTabReselected(index: Int) {}
                    override fun onTabUnselected(index: Int) {}
                    override fun onTabSelected(index: Int) {
                        selectedTabIndex = index
                    }
                })
                setIndicator(
                    QMUITabIndicator(
                        QMUIDisplayHelper.dp2px(context, 2),
                        false,
                        true
                    )
                )
                setDefaultTextSize(ConvertUtils.sp2px(16f), ConvertUtils.sp2px(16f))
            }.lparams(matchParent, autoSize(80))

            view {
                background = resources.getDrawable(R.color.main_hit_bg_color)
            }.lparams(matchParent, autoSize(1)) {
                marginStart = autoSize(32)
                marginEnd = autoSize(32)
            }
            viewPager {
                background = resources.getDrawable(R.color.white)
                viewPager = this
                adapter = pagerAdapter
            }.lparams(matchParent, matchParent)

            segment.setupWithViewPager(viewPager)
            segment.selectTab(selectedTabIndex)
        }

    }
}

/**
 * 套保品种（正常）
 * @property activity AppCompatActivity
 * @property viewModel CommodityInformationViewModel
 * @property swipeToLayout SwipeToLoadLayout
 * @property statusLayout StatusLayout
 * @property spotVarietiesNormalAdapter BaseAdapter<WrStandardData, CommodityViewHolder>
 * @property root _FrameLayout
 * @constructor
 */
class HedgeSpeciesNormalUI(
    private val activity: AppCompatActivity,
    private val viewModel: CommodityInformationViewModel
){
    private lateinit var swipeToLayout: SwipeToLoadLayout
    private lateinit var statusLayout: StatusLayout

    private val spotVarietiesNormalAdapter: BaseAdapter<MiddleGoodsData, CommodityMiddleViewHolder> = BaseAdapter { _, _ -> CommodityMiddleViewHolder(activity, viewModel,"1") }

    init {
        viewModel.queryMiddleGoodsList(status = "1")
    }

    val root = _FrameLayout(activity).apply {
        verticalLayout {
            creatSpotVarietiesHeadUI(text1 = "套保品种/\n代码",text2 = "单位",text3 = "套保比例",text4 = "最后修改时间")

            view {
                background = resources.getDrawable(R.color.line_hint_color)
            }.lparams(matchParent, autoSize(1))

            statusLayout(contentBlock = {
                statusLayout = this
//                bindTaskStatus(viewModule.status)
                swipeToLoadLayout {
                    swipeToLayout = this
                    setEnableRefresh(true)
                    setEnableLoadMore(false)
                    setOnRefreshListener {
                        viewModel.queryMiddleGoodsList(status = "1")
                    }
                    setEnableScrollContentWhenLoaded(false)
                    setEnableLoadMoreWhenContentNotFull(false)
                    recyclerView {
                        background = resources.getDrawable(R.color.white)
                        adapter = spotVarietiesNormalAdapter
                    }.lparams(matchParent, matchParent)
                }
            }, emptyBlock = {
                emptyView(hint = resources.getString(R.string.now_no_data))
            }).lparams(matchParent, matchParent)

            viewModel.middleGoodsNormalList.bindOptional(context){
                if (it?.isEmpty() == true || it?.size == 0){
                    statusLayout.showEmpty()
                }else {
                    if (swipeToLayout.getIsRefreshing()){
                        swipeToLayout.finishRefresh()
                    }
                    statusLayout.showSuccess()
                    spotVarietiesNormalAdapter.setNewData(it)
                }
            }
        }
    }
}

/**
 * 套保品种（停用）
 * @property activity AppCompatActivity
 * @property viewModel CommodityInformationViewModel
 * @property swipeToLayout SwipeToLoadLayout
 * @property statusLayout StatusLayout
 * @property spotVarietiesNormalAdapter BaseAdapter<WrStandardData, CommodityViewHolder>
 * @property root _FrameLayout
 * @constructor
 */
class HedgeSpeciesStopUI(
    private val activity: AppCompatActivity,
    private val viewModel: CommodityInformationViewModel
){
    private lateinit var swipeToLayout: SwipeToLoadLayout
    private lateinit var statusLayout: StatusLayout

    init {
        viewModel.queryMiddleGoodsList(status = "0")
    }

    private val spotVarietiesNormalAdapter: BaseAdapter<MiddleGoodsData, CommodityMiddleViewHolder> = BaseAdapter { _, _ -> CommodityMiddleViewHolder(activity, viewModel,"0") }

    val root = _FrameLayout(activity).apply {
        verticalLayout {
            creatSpotVarietiesHeadUI(text1 = "套保品种/\n代码",text2 = "单位",text3 = "套保比例",text4 = "状态")

            view {
                background = resources.getDrawable(R.color.line_hint_color)
            }.lparams(matchParent, autoSize(1))

            statusLayout(contentBlock = {
                statusLayout = this
//                bindTaskStatus(viewModule.status)
                swipeToLoadLayout {
                    swipeToLayout = this
                    setEnableRefresh(true)
                    setEnableLoadMore(false)
                    setOnRefreshListener {
                        viewModel.queryMiddleGoodsList(status = "0")
                    }
                    setEnableScrollContentWhenLoaded(false)
                    setEnableLoadMoreWhenContentNotFull(false)
                    recyclerView {
                        background = resources.getDrawable(R.color.white)
                        adapter = spotVarietiesNormalAdapter
                    }.lparams(matchParent, matchParent)
                }
            }, emptyBlock = {
                emptyView(hint = resources.getString(R.string.now_no_data))
            }).lparams(matchParent, matchParent)

            viewModel.middleGoodsDisableList.bindOptional(context){
                if (it?.isEmpty() == true || it?.size == 0){
                    statusLayout.showEmpty()
                }else {
                    if (swipeToLayout.getIsRefreshing()){
                        swipeToLayout.finishRefresh()
                    }
                    statusLayout.showSuccess()
                    spotVarietiesNormalAdapter.setNewData(it)
                }
            }
        }
    }
}
